Index: dashboard.pl
===================================================================
--- dashboard.pl	(revision 174)
+++ dashboard.pl	(working copy)
@@ -9,6 +9,7 @@
 # to get Date::Manip.
 
 use Date::Manip;
+use strict;
 
 binmode \*STDOUT, ":utf8";
 
@@ -28,10 +29,11 @@
 print "<col class=\"date\"><col class=\"from\"><col class=\"subject\"><col class=\"result\">
 \n";
 print "<tr>";
-print "<th>Date";
-print "<th>From";
-print "<th>Subject";
-print "<th class=result>Status</tr>\n";
+print "<th>Date</th>";
+print "<th>From</th>";
+print "<th>Subject</th>";
+print "<th class=result>Conformance Status</th>";
+print "<th>Commit Status</th></tr>\n";
 
 open FILE, "ls *.txt | sort -rn |";
 my @patches = <FILE>;
@@ -40,6 +42,12 @@
 for $patch (@patches) {
    chomp($patch);
    my $log = $patch;
+   my $out = $patch;
+   my $status;
+   my $commitstatus;
+   my $patchresult;
+   my $loglink;
+
    $log =~ s/\.txt$/.log/;
    if (-f $log) {
        open FILE, "grep . < $log | tail -1 |";
@@ -49,6 +57,16 @@
    } else {
        $status = "queued";
    }
+
+   $out =~ s/\.txt$/.out/;
+   if (-f $out){
+       open FILE, $out;
+       $patchresult = <FILE>;
+       close FILE;
+       if ($patchresult =~ m/Reversed \(or previously applied\) patch/){
+	   $commitstatus="<a href=\"$out\" class=\"result, pass\">Applied</a>";	   
+       }
+   }
    open FILE, $patch;
    binmode FILE, ":utf8";
    my @patch = <FILE>;
@@ -80,10 +98,11 @@
        $loglink = "<a href=\"$log\" class=\"result, fail\">$status</a>";
    }
    print "<tr>";
-   print "<td class=date>$date &nbsp;";
-   print "<td class=from>$from";
-   print "<td class=subject><a href=\"$patch\">$subject</a>";
-   print "<td class=status>$loglink";
+   print "<td class='date'>$date &nbsp;</td>";
+   print "<td class='from'>$from</td>";
+   print "<td class='subject'><a href=\"$patch\">$subject</a></td>";
+   print "<td class='status'>$loglink</td>";
+   print "<td class='commit'>$commitstatus</td>";
    print "</tr>\n";
 }
 print "</table></body></html>\n";
Index: patchwatcher.sh
===================================================================
--- patchwatcher.sh	(revision 174)
+++ patchwatcher.sh	(working copy)
@@ -219,6 +219,27 @@
 _EOF_
 }
 
+# Attempt to patch all patches and record their output
+retry_all_patches_for_commit()
+{
+    cd $PATCHES
+    for p in `ls *.txt | sed 's/\..*//'`
+    do
+        if egrep -q 'RCS file|^+++.*working copy' < $PATCHES/$NEXT.txt
+        then
+            l=0
+        else
+            l=1
+        fi
+
+        if patch -p$l < $PATCHES/$p.txt > $PATCHES/$p.out 2>&1	
+	then
+	    # the patch succeeded, so undo it.  We don't want side effects.
+	    patch -p$l -R < $PATCHES/$p.txt
+	fi
+    done
+}
+
 # Return true if a patch was tried, false if no patches left to try
 try_one_patch()
 {
@@ -326,6 +347,7 @@
   do
      date
      refresh_tree
+     retry_all_patches_for_commit
      retrieve_patches
      while try_one_patch
      do
